diff -urNEBb gcc-2.95.3-orig/gcc/doprint.c gcc-2.95.3/gcc/doprint.c
--- gcc-2.95.3-orig/gcc/doprint.c	1999-01-06 21:44:19.000000000 +0100
+++ gcc-2.95.3/gcc/doprint.c	2003-12-02 17:50:55.000000000 +0100
@@ -16,7 +16,6 @@
 along with this program; if not, write to the Free Software
 Foundation, 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.  */
 
- */
 
 #include "config.h"
 #include "system.h"
@@ -114,6 +113,7 @@
 		  wide_width = 2;
 		  break;
 		default:
+			#undef abort
 		  abort();
 		}
 	      *sptr++ = *ptr++;
diff -urNEBb gcc-2.95.3-orig/gcc/f/version.c gcc-2.95.3/gcc/f/version.c
--- gcc-2.95.3-orig/gcc/f/version.c	2001-03-16 13:52:16.000000000 +0100
+++ gcc-2.95.3/gcc/f/version.c	2003-12-02 17:50:55.000000000 +0100
@@ -1 +1 @@
-const char *ffe_version_string = "0.5.25 20010315 (release)";
+const char *ffe_version_string = "0.5.25 20010315 (Amiga, Inc. build 20030831)";
diff -urNEBb gcc-2.95.3-orig/gcc/fixinc/fixincl.c gcc-2.95.3/gcc/fixinc/fixincl.c
--- gcc-2.95.3-orig/gcc/fixinc/fixincl.c	1999-06-07 22:26:07.000000000 +0200
+++ gcc-2.95.3/gcc/fixinc/fixincl.c	2003-12-02 17:50:55.000000000 +0100
@@ -345,10 +345,12 @@
       */
   run_compiles ();
 
+#ifndef __amigaos4__
   signal (SIGQUIT, SIG_IGN);
   signal (SIGIOT,  SIG_IGN);
   signal (SIGPIPE, SIG_IGN);
   signal (SIGALRM, SIG_IGN);
+#endif
   signal (SIGTERM, SIG_IGN);
 
   /*
diff -urNEBb gcc-2.95.3-orig/gcc/fixinc/server.c gcc-2.95.3/gcc/fixinc/server.c
--- gcc-2.95.3-orig/gcc/fixinc/server.c	1999-05-30 15:45:17.000000000 +0200
+++ gcc-2.95.3/gcc/fixinc/server.c	2003-12-02 17:50:55.000000000 +0100
@@ -180,7 +180,11 @@
 {
   if (server_id != NULLPROCESS)
     {
+#ifdef __amigaos4__
+      kill ((pid_t) server_id, SIGTERM);
+#else
       kill ((pid_t) server_id, SIGKILL);
+#endif
       server_id = NULLPROCESS;
       fclose (server_pair.pf_read);
       fclose (server_pair.pf_write);
@@ -222,8 +226,10 @@
   if (atexit_done++ == 0)
     atexit (&close_server);
 
+#ifndef __amigaos4__
   signal (SIGPIPE, sig_handler);
   signal (SIGALRM, sig_handler);
+#endif
 
   fputs ("trap : 1\n", server_pair.pf_write);
   fflush (server_pair.pf_write);
diff -urNEBb gcc-2.95.3-orig/gcc/genattrtab.c gcc-2.95.3/gcc/genattrtab.c
--- gcc-2.95.3-orig/gcc/genattrtab.c	1999-04-16 21:52:21.000000000 +0200
+++ gcc-2.95.3/gcc/genattrtab.c	2003-12-02 17:50:55.000000000 +0100
@@ -104,6 +104,10 @@
 # include <sys/resource.h>
 #endif
 
+#ifdef __amigaos__
+#include <limits.h>
+#endif /* __amigaos__ */
+
 /* We must include obstack.h after <sys/time.h>, to avoid lossage with
    /usr/include/sys/stdtypes.h on Sun OS 4.x.  */
 #include "obstack.h"
diff -urNEBb gcc-2.95.3-orig/gcc/getpwd.c gcc-2.95.3/gcc/getpwd.c
--- gcc-2.95.3-orig/gcc/getpwd.c	1998-12-16 21:56:28.000000000 +0100
+++ gcc-2.95.3/gcc/getpwd.c	2003-12-02 17:50:55.000000000 +0100
@@ -7,7 +7,7 @@
    BSD systems) now provides getcwd as called for by POSIX.  Allow for
    the few exceptions to the general rule here.  */
 
-#if !(defined (POSIX) || defined (USG) || defined (VMS)) || defined (HAVE_GETWD)
+#if !(defined (POSIX) || defined (USG) || defined (VMS) || defined(__amigaos__)) || defined (HAVE_GETWD)
 #define getcwd(buf,len) getwd(buf)
 #ifdef MAXPATHLEN
 #define GUESSPATHLEN (MAXPATHLEN + 1)
diff -urNEBb gcc-2.95.3-orig/gcc/ginclude/va-ppc.h gcc-2.95.3/gcc/ginclude/va-ppc.h
--- gcc-2.95.3-orig/gcc/ginclude/va-ppc.h	1999-08-09 07:55:16.000000000 +0200
+++ gcc-2.95.3/gcc/ginclude/va-ppc.h	2003-12-02 17:50:55.000000000 +0100
@@ -190,6 +190,20 @@
   __ptr;								   \
 }))
 
+
+#if defined(__AMIGA__) && defined (__PPC__)
+
+/* OS4 linear vararg support */
+#define va_startlinear(AP, x)			\
+           va_start(AP, x);			\
+           (AP)->gpr = 8;			\
+           (AP)->fpr = 8;
+
+#define va_getlinearva(AP,TYPE)                 \
+           (TYPE)__va_overflow(AP)
+
+#endif
+
 #define va_end(AP)	((void)0)
 
 /* Copy __gnuc_va_list into another variable of this type.  */
diff -urNEBb gcc-2.95.3-orig/gcc/intl/dcgettext.c gcc-2.95.3/gcc/intl/dcgettext.c
--- gcc-2.95.3-orig/gcc/intl/dcgettext.c	1998-12-17 07:45:44.000000000 +0100
+++ gcc-2.95.3/gcc/intl/dcgettext.c	2003-12-02 17:50:55.000000000 +0100
@@ -18,7 +18,7 @@
 #ifdef HAVE_CONFIG_H
 # include <config.h>
 #endif
-
+#define HAVE_GETCWD
 #include <sys/types.h>
 
 #ifdef __GNUC__
@@ -99,6 +99,7 @@
 char *getwd ();
 #  define getcwd(buf, max) getwd (buf)
 # else
+#undef getcwd
 char *getcwd ();
 # endif
 # ifndef HAVE_STPCPY
diff -urNEBb gcc-2.95.3-orig/gcc/libgcc2.c gcc-2.95.3/gcc/libgcc2.c
--- gcc-2.95.3-orig/gcc/libgcc2.c	1999-06-11 05:11:43.000000000 +0200
+++ gcc-2.95.3/gcc/libgcc2.c	2003-12-02 17:50:55.000000000 +0100
@@ -60,9 +60,9 @@
 /* In a cross-compilation situation, default to inhibiting compilation
    of routines that use libc.  */
 
-#if defined(CROSS_COMPILE) && !defined(inhibit_libc)
+/*#if defined(CROSS_COMPILE) && !defined(inhibit_libc)
 #define inhibit_libc
-#endif
+#endif*/
 
 /* Permit the tm.h file to select the endianness to use just for this
    file.  This is used when the endianness is determined when the
diff -urNEBb gcc-2.95.3-orig/gcc/protoize.c gcc-2.95.3/gcc/protoize.c
--- gcc-2.95.3-orig/gcc/protoize.c	1999-04-16 21:52:36.000000000 +0200
+++ gcc-2.95.3/gcc/protoize.c	2003-12-02 17:50:55.000000000 +0100
@@ -62,7 +62,7 @@
 #undef abort
 
 #if ! defined (_WIN32) || defined (__CYGWIN__) || defined (_UWIN)
-#if defined(POSIX) || defined(CONCURRENT)
+#if defined(POSIX) || defined(CONCURRENT) || defined(__amigaos__)
 #include <dirent.h>
 #else
 #include <sys/dir.h>
diff -urNEBb gcc-2.95.3-orig/gcc/toplev.c gcc-2.95.3/gcc/toplev.c
--- gcc-2.95.3-orig/gcc/toplev.c	2001-01-25 15:03:23.000000000 +0100
+++ gcc-2.95.3/gcc/toplev.c	2003-12-02 17:50:55.000000000 +0100
@@ -139,7 +139,7 @@
 
 extern int rtx_equal_function_value_matters;
 
-#if ! (defined (VMS) || defined (OS2))
+#if ! (defined (VMS) || defined (OS2) || defined(__amigaos4__))
 extern char **environ;
 #endif
 extern char *version_string, *language_string;
@@ -924,6 +924,10 @@
   {"pic", &flag_pic, 1,
    "Generate position independent code, if possible"},
   {"PIC", &flag_pic, 2, ""},
+  {"baserel", &flag_pic, 3,
+   "Generate base relative code"},
+  {"baserel32", &flag_pic, 4,
+   "Generate base relative code with no data limits"},
   {"exceptions", &flag_exceptions, 1,
    "Enable exception handling" },
   {"new-exceptions", &flag_new_exceptions, 1,
@@ -1336,6 +1340,9 @@
   if (quiet_flag)
     return 0;
 
+#ifdef __amigaos__
+  return 0;
+#else
 #ifdef __BEOS__
   return 0;
 #else /* not BeOS */
@@ -1395,6 +1402,7 @@
 #endif  /* _SC_CLK_TCK */
 #endif	/* _WIN32 */
 #endif	/* __BEOS__ */
+#endif  /* __amigaos__ */
 }
 
 #define TIMEVAR(VAR, BODY)    \
@@ -2569,7 +2577,11 @@
   /* NA gets INPUT_NAME sans directory names.  */
   while (na > input_name)
     {
-      if (na[-1] == '/')
+      if (na[-1] == '/'
+#ifdef VOL_SEPARATOR
+	  || na[-1] == VOL_SEPARATOR
+#endif
+	  )
 	break;
 #ifdef DIR_SEPARATOR
       if (na[-1] == DIR_SEPARATOR)
@@ -4776,6 +4788,9 @@
 #ifdef DIR_SEPARATOR
 	 && p[-1] != DIR_SEPARATOR
 #endif
+#ifdef VOL_SEPARATOR
+	 && p[-1] != VOL_SEPARATOR
+#endif
 	 )
     --p;
   progname = p;
@@ -5449,7 +5464,7 @@
 
   compile_file (filename);
 
-#if !defined(OS2) && !defined(VMS) && (!defined(_WIN32) || defined (__CYGWIN__)) && !defined(__INTERIX)
+#if !defined(OS2) && !defined(VMS) && (!defined(_WIN32) || defined (__CYGWIN__)) && !defined(__INTERIX) && !defined (__amigaos__)
   if (flag_print_mem)
     {
       char *lim = (char *) sbrk (0);
@@ -5465,7 +5480,7 @@
 #endif /* not USG */
 #endif
     }
-#endif /* ! OS2 && ! VMS && (! _WIN32 || CYGWIN) && ! __INTERIX */
+#endif /* ! OS2 && ! VMS && (! _WIN32 || CYGWIN) && ! __INTERIX && ! __amigaos__*/
 
   if (errorcount)
     exit (FATAL_EXIT_CODE);
diff -urNEBb gcc-2.95.3-orig/gcc/version.c gcc-2.95.3/gcc/version.c
--- gcc-2.95.3-orig/gcc/version.c	2001-03-16 13:52:12.000000000 +0100
+++ gcc-2.95.3/gcc/version.c	2003-12-02 17:50:55.000000000 +0100
@@ -1 +1 @@
-char *version_string = "2.95.3 20010315 (release)";
+char *version_string = "2.95.3 20010315 (Amiga, Inc. build 20030831)";
diff -urNEBb gcc-2.95.3-orig/libiberty/choose-temp.c gcc-2.95.3/libiberty/choose-temp.c
--- gcc-2.95.3-orig/libiberty/choose-temp.c	1999-04-25 02:23:06.000000000 +0200
+++ gcc-2.95.3/libiberty/choose-temp.c	2003-12-02 17:50:55.000000000 +0100
@@ -26,6 +26,8 @@
 #include "config.h"
 #endif
 
+#undef HAVE_SYS_FILE_H
+
 #include <stdio.h>	/* May get P_tmpdir.  */
 #include <sys/types.h>
 #ifdef HAVE_UNISTD_H
@@ -51,6 +53,9 @@
 #if defined (__MSDOS__) || (defined (_WIN32) && ! defined (__CYGWIN__) && ! defined (_UWIN))
 #define DIR_SEPARATOR '\\'
 #endif
+#ifdef __amigaos__
+#define VOL_SEPARATOR ':'
+#endif
 #endif
 
 #ifndef DIR_SEPARATOR
@@ -117,7 +122,9 @@
 #endif
 
   /* Try /usr/tmp, then /tmp.  */
+  #if !defined(__amigaos__)
   base = try (usrtmp, base);
+  #endif
   base = try (tmp, base);
  
   /* If all else fails, use the current directory!  */
@@ -131,7 +138,11 @@
 
   if (len != 0
       && temp_filename[len-1] != '/'
-      && temp_filename[len-1] != DIR_SEPARATOR)
+      && temp_filename[len-1] != DIR_SEPARATOR
+#ifdef VOL_SEPARATOR
+      && temp_filename[len-1] != VOL_SEPARATOR
+#endif
+      )
     temp_filename[len++] = DIR_SEPARATOR;
   strcpy (temp_filename + len, TEMP_FILE);
 
diff -urNEBb gcc-2.95.3-orig/libiberty/getcwd.c gcc-2.95.3/libiberty/getcwd.c
--- gcc-2.95.3-orig/libiberty/getcwd.c	1999-05-26 05:04:08.000000000 +0200
+++ gcc-2.95.3/libiberty/getcwd.c	2003-12-02 17:50:55.000000000 +0100
@@ -25,6 +25,8 @@
 
 #include "config.h"
 
+#undef HAVE_SYS_PARAM_H
+
 #ifdef HAVE_SYS_PARAM_H
 #include <sys/param.h>
 #endif
diff -urNEBb gcc-2.95.3-orig/libiberty/getpagesize.c gcc-2.95.3/libiberty/getpagesize.c
--- gcc-2.95.3-orig/libiberty/getpagesize.c	1998-05-21 09:52:39.000000000 +0200
+++ gcc-2.95.3/libiberty/getpagesize.c	2003-12-02 17:50:55.000000000 +0100
@@ -30,6 +30,8 @@
 
 #include "config.h"
 
+#undef HAVE_SYS_PARAM_H
+
 #include <sys/types.h>
 #ifdef HAVE_SYS_PARAM_H
 #include <sys/param.h>
diff -urNEBb gcc-2.95.3-orig/libiberty/pexecute.c gcc-2.95.3/libiberty/pexecute.c
--- gcc-2.95.3-orig/libiberty/pexecute.c	1999-04-12 00:21:27.000000000 +0200
+++ gcc-2.95.3/libiberty/pexecute.c	2003-12-02 17:50:55.000000000 +0100
@@ -116,7 +116,7 @@
    runs the requested programs.
 */
 
-#ifdef __MSDOS__
+#if defined(__MSDOS__) && !defined(__amigaos__)
 
 /* MSDOS doesn't multitask, but for the sake of a consistent interface
    the code behaves like it does.  pexecute runs the program, tucks the
@@ -230,7 +230,7 @@
 
 #endif /* MSDOS */
 
-#if defined (_WIN32) && ! defined (_UWIN)
+#if defined (_WIN32) && ! defined (_UWIN) && !defined(__amigaos__)
 
 #include <process.h>
 
@@ -602,7 +602,7 @@
 
 /* include for Unix-like environments but not for Dos-like environments */
 #if ! defined (__MSDOS__) && ! defined (OS2) && ! defined (MPW) \
-    && ! (defined (_WIN32) && ! defined (_UWIN))
+    && ! (defined (_WIN32) && ! defined (_UWIN)) && ! defined(__amigaos__)
 
 extern int execv ();
 extern int execvp ();
@@ -732,3 +732,126 @@
 }
 
 #endif /* ! __MSDOS__ && ! OS2 && ! MPW && ! (_WIN32 && ! _UWIN) */
+
+#if defined(__amigaos__)
+
+/* For communicating information from pexecute to pwait.  */
+static int last_pid = 0;
+static int last_status = 0;
+static int last_reaped = 0;
+
+int
+pexecute (program, argv, this_pname, temp_base, errmsg_fmt, errmsg_arg, flags)
+     const char *program;
+     char * const *argv;
+     const char *this_pname;
+     const char *temp_base;
+     char **errmsg_fmt, **errmsg_arg;
+     int flags;
+{
+  int rc;
+  char *scmd,*s;
+  int i,j,c,len,arglen;
+  int need_quote;
+
+  last_pid++;
+  if (last_pid < 0)
+    last_pid = 1;
+
+  if ((flags & PEXECUTE_ONE) != PEXECUTE_ONE)
+    abort ();
+
+  len = 0;
+
+  for(i = 0 ; argv[i] != NULL ; i++)
+  {
+    arglen = strlen(argv[i]);
+
+    len += 1 + arglen;
+
+    for(j = 0, need_quote = 0 ; j < arglen ; j++)
+    {
+      c = argv[i][j];
+
+      if(isspace(c))
+        need_quote = 1;
+      else if (c == '\"')
+        len++;
+    }
+
+    if(need_quote)
+      len += 2;
+  }
+
+  s = scmd = (char *) xmalloc (len+1);
+
+  for(i = 0 ; argv[i] != NULL ; i++)
+  {
+    arglen = strlen(argv[i]);
+
+    for(j = 0, need_quote = 0 ; j < arglen ; j++)
+    {
+      if(isspace(argv[i][j]))
+        need_quote = 1;
+    }
+
+    if(s != scmd)
+      (*s++) = ' ';
+
+    if(need_quote)
+      (*s++) = '\"';
+
+    for(j = 0 ; j < arglen ; j++)
+    {
+      c = argv[i][j];
+      if(c == '\"')
+        (*s++) = '*';
+
+      (*s++) = c;
+    }
+
+    if(need_quote)
+      (*s++) = '\"';
+  }
+
+  (*s) = '\0';
+
+  rc = system (scmd);
+
+  free (scmd);
+
+  if (rc == -1)
+    {
+      *errmsg_fmt = install_error_msg;
+      *errmsg_arg = program;
+      return -1;
+    }
+
+  /* Tuck the status away for pwait, and return a "pid".  */
+  last_status = rc << 8;
+  return last_pid;
+}
+
+int
+pwait (pid, status, flags)
+     int pid;
+     int *status;
+     int flags;
+{
+  /* On MSDOS each pexecute must be followed by it's associated pwait.  */
+  if (pid != last_pid
+      /* Called twice for the same child?  */
+      || pid == last_reaped)
+    {
+      /* ??? ECHILD would be a better choice.  Can we use it here?  */
+      errno = EINVAL;
+      return -1;
+    }
+  /* ??? Here's an opportunity to canonicalize the values in STATUS.
+     Needed?  */
+  *status = last_status;
+  last_reaped = last_pid;
+  return last_pid;
+}
+
+#endif /* __amigaos__ */
diff -urNEBb gcc-2.95.3-orig/libiberty/strerror.c gcc-2.95.3/libiberty/strerror.c
--- gcc-2.95.3-orig/libiberty/strerror.c	1998-05-16 01:42:41.000000000 +0200
+++ gcc-2.95.3/libiberty/strerror.c	2003-12-03 13:59:53.000000000 +0100
@@ -462,7 +462,7 @@
 
 #else
 
-extern int sys_nerr;
+/*extern const int sys_nerr;*/
 extern char *sys_errlist[];
 
 #endif
diff -urNEBb gcc-2.95.3-orig/libiberty/strsignal.c gcc-2.95.3/libiberty/strsignal.c
--- gcc-2.95.3-orig/libiberty/strsignal.c	1998-05-16 01:42:42.000000000 +0200
+++ gcc-2.95.3/libiberty/strsignal.c	2003-12-02 17:50:55.000000000 +0100
@@ -7,6 +7,8 @@
 
 #include "config.h"
 
+#undef HAVE_SYS_SIGLIST
+
 /* We need to declare sys_siglist, because even if the system provides
    it we can't assume that it is declared in <signal.h> (for example,
    SunOS provides sys_siglist, but it does not declare it in any
@@ -370,6 +372,8 @@
 
 */
 
+#if !defined(__amigaos__)
+
 int
 signo_max ()
 {
@@ -383,6 +387,7 @@
   return (maxsize - 1);
 }
 
+#endif /* __amigaos__ */
 
 /*
 
@@ -414,6 +419,7 @@
 
 */
 
+#if !defined(__amigaos__)
 #ifndef HAVE_STRSIGNAL
 
 const char *
@@ -453,6 +459,7 @@
 }
 
 #endif /* ! HAVE_STRSIGNAL */
+#endif /* __amigaos__ */
 
 /*
 
diff -urNEBb gcc-2.95.3-orig/libiberty/vasprintf.c gcc-2.95.3/libiberty/vasprintf.c
--- gcc-2.95.3-orig/libiberty/vasprintf.c	1998-09-07 22:37:12.000000000 +0200
+++ gcc-2.95.3/libiberty/vasprintf.c	2003-12-02 17:50:55.000000000 +0100
@@ -31,6 +31,8 @@
 int global_total_width;
 #endif
 
+#undef vasprintf
+
 unsigned long strtoul ();
 char *malloc ();
 
diff -urNEBb gcc-2.95.3-orig/libiberty/vsprintf.c gcc-2.95.3/libiberty/vsprintf.c
--- gcc-2.95.3-orig/libiberty/vsprintf.c	1998-05-16 01:14:55.000000000 +0200
+++ gcc-2.95.3/libiberty/vsprintf.c	2003-12-02 17:50:55.000000000 +0100
@@ -37,6 +37,7 @@
      const char *format;
      va_list ap;
 {
+#if 0
   FILE b;
   int ret;
 #ifdef VMS
@@ -51,5 +52,5 @@
   ret = _doprnt(format, ap, &b);
   putc('\0', &b);
   return ret;
-
+#endif
 }
